ch.qos.logback.core.html

## Class HTMLLayoutBase<E>

- java.lang.Object
- - ch.qos.logback.core.spi.ContextAwareBase
  - - ch.qos.logback.core.LayoutBase<E>
    - - ch.qos.logback.core.html.HTMLLayoutBase<E>

All Implemented Interfaces:
  Layout<E>, ContextAware, LifeCycle

Direct Known Subclasses:
  HTMLLayout, HTMLLayout

    public abstract class HTMLLayoutBase<E>
    extends LayoutBase<E>

This class is a base class for HTMLLayout classes part of other logback modules such as logback-classic and logback-access.

Author:
  Sébastien Pennec

### Field Summary

Fields
`protected long` `counter`
`protected CssBuilder` `cssBuilder`
`protected Converter<E>` `head`
`protected String` `pattern`
`protected String` `title`

### Fields inherited from class ch.qos.logback.core.LayoutBase

`started`

### Fields inherited from class ch.qos.logback.core.spi.ContextAwareBase

`context`

### Constructor Summary

Constructors
Constructor and Description
`HTMLLayoutBase()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected String` `computeConverterName(Converter c)`
`String` `getContentType()` Returns the content type output by this layout, i.e "text/html".
`CssBuilder` `getCssBuilder()`
`protected abstract Map<String,String>` `getDefaultConverterMap()`
`Map<String,String>` `getEffectiveConverterMap()` Returns a map where the default converter map is merged with the map contained in the context.
`String` `getFileFooter()` Returns the appropriate HTML footers.
`String` `getFileHeader()` Returns appropriate HTML headers.
`String` `getPattern()` Returns the value of the ConversionPattern option.
`String` `getPresentationFooter()` Return the footer of the logging event formatting.
`String` `getPresentationHeader()` Return the header of the logging event formatting.
`String` `getTitle()` Returns the current value of the Title option.
`void` `setCssBuilder(CssBuilder cssBuilder)`
`void` `setPattern(String conversionPattern)` Set the ConversionPattern option.
`void` `setTitle(String title)` The Title option takes a String value.
`void` `start()` Parses the pattern and creates the Converter linked list.
`protected void` `startNewTableIfLimitReached(StringBuilder sbuf)`

### Methods inherited from class ch.qos.logback.core.LayoutBase

`getContext, isStarted, setContext, setFileFooter, setFileHeader, setPresentationFooter, setPresentationHeader, stop`

### Methods inherited from class ch.qos.logback.core.spi.ContextAwareBase

`addError, addError, addInfo, addInfo, addStatus, addWarn, addWarn, getDeclaredOrigin, getStatusManager`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface ch.qos.logback.core.Layout

`doLayout`

### Methods inherited from interface ch.qos.logback.core.spi.ContextAware

`addError, addError, addInfo, addInfo, addStatus, addWarn, addWarn`

### Field Detail

#### pattern

    protected String pattern

#### head

    protected Converter<E> head

#### title

    protected String title

#### cssBuilder

    protected CssBuilder cssBuilder

#### counter

    protected long counter

### Constructor Detail

#### HTMLLayoutBase

    public HTMLLayoutBase()

### Method Detail

#### setPattern

    public void setPattern(String conversionPattern)

Set the ConversionPattern option. This is the string which controls formatting and consists of a mix of literal content and conversion specifiers.

#### getPattern

    public String getPattern()

Returns the value of the ConversionPattern option.

#### getCssBuilder

    public CssBuilder getCssBuilder()

#### setCssBuilder

    public void setCssBuilder(CssBuilder cssBuilder)

#### start

    public void start()

Parses the pattern and creates the Converter linked list.

Specified by:
  `start` in interface `LifeCycle`
Overrides:
  `start` in class `LayoutBase<E>`

#### getDefaultConverterMap

    protected abstract Map<String,String> getDefaultConverterMap()

#### getEffectiveConverterMap

    public Map<String,String> getEffectiveConverterMap()

Returns a map where the default converter map is merged with the map contained in the context.

#### setTitle

    public void setTitle(String title)

The Title option takes a String value. This option sets the document title of the generated HTML document.

Defaults to 'Logback Log Messages'.

#### getTitle

    public String getTitle()

Returns the current value of the Title option.

#### getContentType

    public String getContentType()

Returns the content type output by this layout, i.e "text/html".

Specified by:
  `getContentType` in interface `Layout<E>`
Overrides:
  `getContentType` in class `LayoutBase<E>`
Returns:

#### getFileHeader

    public String getFileHeader()

Returns appropriate HTML headers.

Specified by:
  `getFileHeader` in interface `Layout<E>`
Overrides:
  `getFileHeader` in class `LayoutBase<E>`
Returns:
  The header.

#### getPresentationHeader

    public String getPresentationHeader()

Description copied from interface: `Layout`
Return the header of the logging event formatting. The returned value may be null.

Specified by:
  `getPresentationHeader` in interface `Layout<E>`
Overrides:
  `getPresentationHeader` in class `LayoutBase<E>`
Returns:
  The header.

#### getPresentationFooter

    public String getPresentationFooter()

Description copied from interface: `Layout`
Return the footer of the logging event formatting. The returned value may be null.

Specified by:
  `getPresentationFooter` in interface `Layout<E>`
Overrides:
  `getPresentationFooter` in class `LayoutBase<E>`
Returns:
  The footer.

#### getFileFooter

    public String getFileFooter()

Returns the appropriate HTML footers.

Specified by:
  `getFileFooter` in interface `Layout<E>`
Overrides:
  `getFileFooter` in class `LayoutBase<E>`
Returns:
  The footer.

#### startNewTableIfLimitReached

    protected void startNewTableIfLimitReached(StringBuilder sbuf)

#### computeConverterName

    protected String computeConverterName(Converter c)